<script lang="ts" setup>
import {
  Select,
  SelectContent,
  SelectGroup,
  SelectItem,
  SelectLabel,
  SelectTrigger,
  SelectValue,
} from '@/lib/registry/new-york/ui/select'
import {
  DropdownMenu,
  DropdownMenuContent,
  DropdownMenuItem,
  DropdownMenuSeparator,
  DropdownMenuTrigger,
} from '@/lib/registry/new-york/ui/dropdown-menu'
import { onMounted, ref } from 'vue'
import {
  Collapsible,
  CollapsibleContent,
  CollapsibleTrigger,
} from '@/components/ui/collapsible'
import Button from '@/lib/registry/new-york/ui/button/Button.vue';
import WasmUploader, { type WasmUploadedEmit } from './WasmUploader.vue';
import { getParserForId, getParserForWasmFile, preBuiltGrammarIds } from './parser';
import { useUserStore } from '@/stores/user_settings';
import { getDB, type WasmFileOutputDocData } from '@/local_db/db';


const isOpen = ref(false)
const userStore = useUserStore()

const onWasmUploaded = async (emit: WasmUploadedEmit) => {
  const parser = await getParserForWasmFile(emit.file)
  await Promise.all([userStore.setParser({
    parser,
    parserId: emit.name,
  }), fetchWasmFiles()])
}

const wasmFiles = ref<WasmFileOutputDocData[]>([]);

const onParserSelect = async (selection: string) => {
  const parser = await getParserForId(selection)
  await Promise.all([userStore.setParser({
    parser,
    parserId: selection,
  }), fetchWasmFiles()])
}

const fetchWasmFiles = async () => {
  const db = await getDB();
  wasmFiles.value = await db.getWasmFiles();
  console.log('shayon testing', wasmFiles.value)
}

onMounted(fetchWasmFiles)


</script>

<template>
  <div class="space-y-2">
    <Select @update:model-value="onParserSelect">
      <SelectTrigger>
        <SelectValue :placeholder="userStore.parserId === '' ? 'select a parser' : userStore.parserId" />
      </SelectTrigger>
      <SelectContent>
        <SelectGroup>
          <SelectLabel>Pre-Built Parsers</SelectLabel>
          <SelectItem v-for="parser in preBuiltGrammarIds" :key="parser" :value="parser">
            {{ parser }}
          </SelectItem>
        </SelectGroup>
        <SelectGroup>
          <SelectLabel>Custom Uploaded Parsers</SelectLabel>
          <SelectItem v-for="wasm in wasmFiles" :key="wasm.name" :value="wasm.name">
            {{ wasm.name }} ({{ wasm.filename }})
          </SelectItem>

        </SelectGroup>


      </SelectContent>
    </Select>

    <Collapsible v-model:open="isOpen">
      <Button variant="secondary">
        <CollapsibleTrigger><span class="text-sm mr-2">Custom Parsers</span>
          <v-icon name="bi-chevron-compact-down" scale=".8" animation="wrench" hover="true" speed="fast" />
        </CollapsibleTrigger>
      </Button>
      <CollapsibleContent>
        <WasmUploader @wasm-uploaded="onWasmUploaded" />
      </CollapsibleContent>
    </Collapsible>

  </div>

  <!-- <div class="mt-4">
    <label for="parser-select" class="block mb-2">Select current parser:</label>
    <select id="parser-select" v-model="userStore.parserId" @change="onParserSelect" class="border rounded px-2 py-1">
      <option value="">Select a parser</option>
      <optgroup label="Pre-built parsers">
        <option v-for="parser in preBuiltGrammarIds" :key="parser" :value="parser">{{ parser }}</option>
      </optgroup>
      <optgroup label="Custom parsers">
        <option v-for="wasm in wasmFiles" :key="wasm.name" :value="wasm.name">
          {{ wasm.name }} ({{ wasm.filename }})
        </option>
      </optgroup>
    </select>
  </div> -->

</template>